std::allocator_traits< _Alloc >(3)

NAME
std::allocator_traits< _Alloc > - Uniform interface to all allocator types.

SYNOPSIS

Inherits std::__allocator_traits_base.

Inherited by __gnu_cxx::__alloc_traits< _Alloc, typename >.

  Public Types
typedef _Alloc allocator_type
The allocator type.
using const_pointer = typename _Ptr< __c_pointer, const value_type >::type
The allocator's const pointer type.
using const_void_pointer = typename _Ptr< __cv_pointer, const void >::type
The allocator's const void pointer type.
using difference_type = typename _Diff< _Alloc, pointer >::type
The allocator's difference type.
using is_always_equal = __detected_or_t< typename is_empty< _Alloc >::type, __equal, _Alloc >
Whether all instances of the allocator type compare equal.
using pointer = __detected_or_t< value_type *, __pointer, _Alloc >
The allocator's pointer type.
using propagate_on_container_copy_assignment = __detected_or_t< false_type, __pocca, _Alloc >
How the allocator is propagated on copy assignment.
using propagate_on_container_move_assignment = __detected_or_t< false_type, __pocma, _Alloc >
How the allocator is propagated on move assignment.
using propagate_on_container_swap = __detected_or_t< false_type, __pocs, _Alloc >
How the allocator is propagated on swap.
template<typename _Tp > using rebind_alloc = __alloc_rebind< _Alloc, _Tp >
template<typename _Tp > using rebind_traits = allocator_traits< rebind_alloc< _Tp > >
using size_type = typename _Size< _Alloc, difference_type >::type
The allocator's size type.
typedef _Alloc::value_type value_type
The allocated type.
using void_pointer = typename _Ptr< __v_pointer, void >::type
The allocator's void pointer type.

  Static Public Member Functions
static constexpr pointer allocate (_Alloc &__a, size_type __n)
Allocate memory.
static constexpr pointer allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
Allocate memory.
template<typename _Tp , typename... _Args> static constexpr auto construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(noexcept(_S_construct(__a, __p, std::forward< _Args >(__args)...))) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
Construct an object of type _Tp.
static constexpr void deallocate (_Alloc &__a, pointer __p, size_type __n)
Deallocate memory.
template<typename _Tp > static constexpr void destroy (_Alloc &__a, _Tp *__p) noexcept(noexcept(_S_destroy(__a, __p, 0)))
Destroy an object of type _Tp.
static constexpr size_type max_size (const _Alloc &__a) noexcept
The maximum supported allocation size.
static constexpr _Alloc select_on_container_copy_construction (const _Alloc &__rhs)
Obtain an allocator to use when copying a container.

  Protected Types
template<typename _Tp > using __c_pointer = typename _Tp::const_pointer
template<typename _Tp > using __cv_pointer = typename _Tp::const_void_pointer
template<typename _Tp > using __equal = typename _Tp::is_always_equal
template<typename _Tp > using __pocca = typename _Tp::propagate_on_container_copy_assignment
template<typename _Tp > using __pocma = typename _Tp::propagate_on_container_move_assignment
template<typename _Tp > using __pocs = typename _Tp::propagate_on_container_swap
template<typename _Tp > using __pointer = typename _Tp::pointer
template<typename _Tp > using __v_pointer = typename _Tp::void_pointer

Detailed Description

  template<typename _Alloc>
struct std::allocator_traits< _Alloc >" Uniform interface to all allocator types.

Definition at line 86 of file bits/alloc_traits.h.

Member Typedef Documentation

  template<typename _Alloc > typedef _Alloc std::allocator_traits< _Alloc >::allocator_type

The allocator type.

Definition at line 89 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::const_pointer = typename _Ptr<__c_pointer, const value_type>::type

The allocator's const pointer type. Alloc::const_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const value_type>

Definition at line 138 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::const_void_pointer = typename _Ptr<__cv_pointer, const void>::type

The allocator's const void pointer type. Alloc::const_void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const void>

Definition at line 154 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::difference_type = typename _Diff<_Alloc, pointer>::type

The allocator's difference type. Alloc::difference_type if that type exists, otherwise pointer_traits<pointer>::difference_type

Definition at line 162 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::is_always_equal = __detected_or_t<typename is_empty<_Alloc>::type, __equal, _Alloc>

Whether all instances of the allocator type compare equal. Alloc::is_always_equal if that type exists, otherwise is_empty<Alloc>::type

Definition at line 205 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::pointer = __detected_or_t<value_type*, __pointer, _Alloc>

The allocator's pointer type. Alloc::pointer if that type exists, otherwise value_type*

Definition at line 98 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment = __detected_or_t<false_type, __pocca, _Alloc>

How the allocator is propagated on copy assignment. Alloc::propagate_on_container_copy_assignment if that type exists, otherwise false_type

Definition at line 178 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::propagate_on_container_move_assignment = __detected_or_t<false_type, __pocma, _Alloc>

How the allocator is propagated on move assignment. Alloc::propagate_on_container_move_assignment if that type exists, otherwise false_type

Definition at line 187 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::propagate_on_container_swap = __detected_or_t<false_type, __pocs, _Alloc>

How the allocator is propagated on swap. Alloc::propagate_on_container_swap if that type exists, otherwise false_type

Definition at line 196 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::size_type = typename _Size<_Alloc, difference_type>::type

The allocator's size type. Alloc::size_type if that type exists, otherwise make_unsigned<difference_type>::type

Definition at line 170 of file bits/alloc_traits.h.

  template<typename _Alloc > typedef _Alloc::value_type std::allocator_traits< _Alloc >::value_type

The allocated type.

Definition at line 91 of file bits/alloc_traits.h.

  template<typename _Alloc > using std::allocator_traits< _Alloc >::void_pointer = typename _Ptr<__v_pointer, void>::type

The allocator's void pointer type. Alloc::void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<void>

Definition at line 146 of file bits/alloc_traits.h.

Member Function Documentation

  template<typename _Alloc > static constexpr pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n) [inline], [static], [constexpr]

Allocate memory.

Parameters
    __a An allocator.
    __n The number of objects to allocate space for.

Calls a.allocate(n)

Definition at line 313 of file bits/alloc_traits.h.

Referenced by std::__allocate_guarded().

  template<typename _Alloc > static constexpr pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n, const_void_pointer __hint) [inline], [static], [constexpr]

Allocate memory.

Parameters
    __a An allocator.
    __n The number of objects to allocate space for.
    __hint Aid to locality.

Returns
    Memory of suitable size and alignment for n objects of type value_type

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns a.allocate(n)

Definition at line 328 of file bits/alloc_traits.h.

  template<typename _Alloc > template<typename _Tp , typename... _Args> static constexpr auto std::allocator_traits< _Alloc >::construct (_Alloc & __a, _Tp * __p, _Args &&... __args) -> decltype(_S_construct(__a, __p, std::forward<_Args>(__args)...))
     [inline], [static], [constexpr], [noexcept]"

Construct an object of type _Tp.

Parameters
    __a An allocator.
    __p Pointer to memory of suitable size and alignment for Tp
    __args Constructor arguments.

Calls __a.construct(__p, std::forward<Args>(__args)...) if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 356 of file bits/alloc_traits.h.

  template<typename _Alloc > static constexpr void std::allocator_traits< _Alloc >::deallocate (_Alloc & __a, pointer __p, size_type __n) [inline], [static], [constexpr]

Deallocate memory.

Parameters
    __a An allocator.
    __p Pointer to the memory to deallocate.
    __n The number of objects space was allocated for.

Calls a.deallocate(p, n)

Definition at line 340 of file bits/alloc_traits.h.

Referenced by std::__allocated_ptr< _Alloc >::~__allocated_ptr().

  template<typename _Alloc > template<typename _Tp > static constexpr void std::allocator_traits< _Alloc >::destroy (_Alloc & __a, _Tp * __p) [inline], [static], [constexpr], [noexcept]

Destroy an object of type _Tp.

Parameters
    __a An allocator.
    __p Pointer to the object to destroy

Calls __a.destroy(__p) if that expression is well-formed, otherwise calls __p->~_Tp()

Definition at line 372 of file bits/alloc_traits.h.

Referenced by std::_Destroy().

  template<typename _Alloc > static constexpr size_type std::allocator_traits< _Alloc >::max_size (const _Alloc & __a) [inline], [static], [constexpr], [noexcept]

The maximum supported allocation size.

Parameters
    __a An allocator.

Returns
    __a.max_size() or numeric_limits<size_type>::max()

Returns __a.max_size() if that expression is well-formed, otherwise returns numeric_limits<size_type>::max()

Definition at line 385 of file bits/alloc_traits.h.

Referenced by std::forward_list< _Tp, _Alloc >::max_size(), and std::list< __inp, __rebind_inp >::max_size().

  template<typename _Alloc > static constexpr _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction (const _Alloc & __rhs) [inline], [static], [constexpr]

Obtain an allocator to use when copying a container.

Parameters
    __rhs An allocator.

Returns
    __rhs.select_on_container_copy_construction() or __rhs

Returns __rhs.select_on_container_copy_construction() if that expression is well-formed, otherwise returns __rhs

Definition at line 397 of file bits/alloc_traits.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.